function [x_n,y_n] = function_FindNextPoint(PointStatus, x, y, LastPoint)

[LX LY] = size(PointStatus);
[FourNeighborXY, EightNeighborXY] = function_FindNeighbors(LX,LY,x,y);

if ~isempty(LastPoint)
    PointStatus(LastPoint(1),LastPoint(2))=0;
end

FourNeighborValue =[];
for j=1:1:size(FourNeighborXY,1)
    FourNeighborValue = [FourNeighborValue; PointStatus(FourNeighborXY(j,1), FourNeighborXY(j,2))];
end

EightNeighborValue =[];
for j=1:1:size(EightNeighborXY,1)
    EightNeighborValue = [EightNeighborValue; PointStatus(EightNeighborXY(j,1),EightNeighborXY(j,2))];
end

ValidFourNeighbor_ID = find(FourNeighborValue~=0);
ValidEightNeighbor_ID = find(EightNeighborValue~=0);

if ~isempty(ValidFourNeighbor_ID) & ~isempty(ValidEightNeighbor_ID)
    display('Error in find next point');
end

if ~isempty(ValidFourNeighbor_ID)
    NextPoint = FourNeighborXY(ValidFourNeighbor_ID,:);
elseif ~isempty(ValidEightNeighbor_ID)
    NextPoint = EightNeighborXY(ValidEightNeighbor_ID,:);
else
    NextPoint= zeros(0,2);
end

if ~isempty(NextPoint)
    x_n = NextPoint(1);
    y_n = NextPoint(2);
else
    x_n=[];
    y_n=[];
end

