%% set the value of node
%node is a struct type
%node.num: the label of segment.
%node.pixel: the coordinate of vertex in this node.
%node.vertex: the vertex of this segment
%node.vertex.num: the label of segment
%node.vertex.N : the number of which vertex
%node.vertex.junction: the junction connected to this vertex of this segment.
%node.vertex.segment: the segments connect to this segment by this vertex.
%node.vertex.pixel: the terminal pixel of this vertex of this segment.
%node.vertex(i).Orientation: the orientation of this segment in this vertex(i).
%node.ids: the junction connect to this segment

function node=junction_attach_to_segment(body,junction,junction_node)
node=cell(0,0);


for i=1:max(max(body))
%     i=35;
    node(i).num=i;
    node(i).pixel=[];
    %check if it is connected to the roots
    Thisnode=(body==i);
    tempstat=function_DetermineStatus(Thisnode);%here leaf means 3 body means 1
    [tx,ty]=find(tempstat==3);
    endpoints=[tx(1),ty(1);tx(2),ty(2)];
    n=0;
    
    %% set the value of node.vertex.(segment,pixel,junction,N,num) and node.pixel
    for j=1:2
        [eno,eco]=function_numofneighbours(endpoints(j,1),endpoints(j,2),junction>0);
        for k=1:eno
            n=n+1;
            node(i).vertex(n).num=i;
            node(i).vertex(n).N=n;
            junc=junction(eco(k,1),eco(k,2));
            node(i).vertex(n).junction=junc;
            node(i).vertex(n).segment=setdiff(junction_node(junc).ids,i);
            
            vertex=junction_node(junc).vertex;
            for l=1:size(vertex,1)                
                a=vertex(l,1);
                b=vertex(l,2);
                if body(a,b)==i
                    node(i).vertex(n).pixel=[a,b];
                    node(i).pixel=[node(i).pixel;a,b];
                end
            end            
        end
    end
    
    %% set the value of node.vertex(i).Orientation
    SSK=Thisnode;
    SSK_back = SSK;
    PointStatus = function_DetermineStatus(SSK);
    [p1,p2] = find(PointStatus==3);    
    [CurveDirection] = function_CalculateOrientation(SSK);    
   
    for ii=1:length(p1)
        [tno,tco]=function_numofneighbours(p1(ii),p2(ii),junction>0);
        for jj=1:tno
            % if (statskel(tco(jj,1),tco(jj,2))~=1&&statskel(tco(jj,1),tco(jj,2))~=2&&statskel(tco(jj,1),tco(jj,2))~=0)
            junc=junction(tco(jj,1),tco(jj,2));
            Connec=junction_node(junc).ids;
            for kk=1:length(node(i).vertex)
                Cliqueconn=[i,node(i).vertex(kk).segment];
                len=intersect(Cliqueconn,Connec);
                if(length(len)==length(Cliqueconn)&&length(len)==length(Connec))
                    [endOrientation] = function_CalculateFeatures_own( SSK_back, SSK,CurveDirection,PointStatus, [p1(ii),p2(ii)]);
                    % Node(i).Clique(kk).Curvature = endCurvature;
                    node(i).vertex(kk).Orientation = endOrientation;
                end
            end
            % end
        end
    end
    
end

%% set the value of node.ids: the junction connect to this segment
for i=1:length(node);
    node(i).ids=[];
end

for i=1:max(junction(:))
    s=size(junction_node(i).vertex,1);
    if s>1
        for j=1:s
            num=body(junction_node(i).vertex(j,1),junction_node(i).vertex(j,2));
            node(num).ids=[node(num).ids,i];
        end
    end
end

end
