% Function to find the adjacency matrix
function adj=find_adj(body,node,junction_node)

%short code expression,just need the parameter----node
% adj=zeros(size(node,2));
% for i=1:size(node,2)
%     for j=1:size(node(i).vertex,2)
%         for k=1:length(node(i).vertex(j).segment)
%             adj(node(i).num,node(i).vertex(j).segment(k))=1;
%         end
%     end
% end

adj=zeros(max(max(body)));
for i=1:size(adj,1)
    conn=node(i).ids;
    for j=1:length(conn)
        a=conn(j);
        if ~isempty(junction_node(a))
            connected_node=junction_node(a).ids;
            connected_node=setdiff(connected_node,i);
            for k=1:length(connected_node)
                adj(i,connected_node(k))=1;
                adj(connected_node(k),i)=1;
            end
        end
    end
end

adj=sparse(adj);
end