function [terminal_node,non_terminal]=find_terminal_segment(body,junction,root_node,bw_body_false,bw_junction_false)
if nargin==3
    bw_body=body>0;
    bw_junction=junction>0;
elseif nargin==5
    bw_body=bw_body_false;
    bw_junction=bw_junction_false;
end

img=bw_body|bw_junction;
neighbour_count = imfilter(uint8(img), ones(3));
bw_body = neighbour_count <=3 & img;
bw_ends = neighbour_count <=2 & img;
% Find the terminal segments - i.e. those containing end points
bw_terminal = imreconstruct(bw_ends, bw_body);
all_terminals=unique(body .*(bw_terminal));
non_terminal=setdiff(1:max(max(body)),all_terminals);
terminal_node=setdiff(setdiff(all_terminals,root_node),0);
end