% Remove the small segment inside the crossovers
% some error, change bw_body_false,bw_junction_false to
% bw_body,bw_junction!!!!!!!!!!!!!!!!!!!
function [bw_body,bw_junction]=remove_small_segment(body,junction,root,theta,len)
%jaydeep false code;
% bw_body_false=body>0;
% bw_junction_false=junction>0;

%---------------------------------------------


[body,junction]=get_clear_map(body,junction);
junction_node=segment_attach_to_junction(body,junction);
node=junction_attach_to_segment(body,junction,junction_node);
% [node,junction_node]=get_information(body,junction);
% adj=find_adj(body,node,junction_node);

% remove the spur segment
[root_node,root_pixel]=find_root_segment_pixel(body,root);
[terminal_node,non_terminal]=find_terminal_segment(body,junction,root_node);%,bw_body_false,bw_junction_false);

bw_body=body>0;
bw_junction=junction>0;
l12=zeros(97,1);
theta12=zeros(97,1);
theta22=zeros(97,1);
flag2=zeros(97,1);
for i=1:length(non_terminal)
%     if non_terminal(i)==177
%         1;
%     end
    [l1,theta1,theta2,flag]=function_find_non_terminal_para(node,body,non_terminal,i);
    if ~isempty(l1)
    l12(i)=l1;
    end
    if ~isempty(theta1)
    theta12(i)=theta1;
    end
    if ~isempty(theta2)
    theta22(i)=theta2;
    end
    if ~isempty(flag)
    flag2(i)=flag;
    end
    if flag==1
        if l1<len  && theta1<deg2rad(theta) && theta2<deg2rad(theta)
            %figure,imshow(nodesegment==non_terminal(i))
            %l1,rad2deg(theta1),rad2deg(theta2)
            
            bw_body(body==non_terminal(i))=0;
            bw_junction(body==non_terminal(i))=1;
            %jaydeep false code
%             bw_body_false(body==non_terminal(i))=0;
%             bw_junction_false(body==non_terminal(i))=1;
            
           
        end
    end    
end

end

function [body,junction]=get_clear_map(body,junction)
% Code for vessel segmnets to node structure conversion code.
% First check whether any segment has one pixel only. Which is not proper
% for angle calculations.

bw_body=body>0;
bw_junction=junction>0;

%=============================================================
% Code for checking whether all the segments have at least 2 pixels.
CC = bwconncomp(bw_body);
numPixels = cellfun(@numel,CC.PixelIdxList);
[idx]=find(numPixels<2);
if ~isempty(idx)
    for jj=1:length(idx)
        bw_body(CC.PixelIdxList{idx(jj)})=false;
    end
end
%==============================================================
body=bwlabel(bw_body);
junction=bwlabel(bw_junction);

%Finding the nodes connected to each junction and the connecting points and their center
%junction_node.ids: the segment label connects to the junction.
%junction_node.num: the label of junction.
%junction_node.vertex: the vertex which is in the segment map of the junction.
%junction_node.center: the center of the vertexs.
junction_node=segment_attach_to_junction(body,junction);

%=================================================================

%delete false vessel segment
for i=1:length(junction_node)
    cc=[];
    if length(junction_node(i).ids)>1 &&  length(junction_node(i).ids) ~= size(junction_node(i).vertex,1)
        for j=1:size(junction_node(i).vertex,1)
            cc=[cc;body(junction_node(i).vertex(j,1),junction_node(i).vertex(j,2))];
        end
        [a,b]=hist(cc,unique(cc));
        for j=1:length(a)
            if a(j)>1
                bw_junction(body==b(j))=true;
                bw_body(body==b(j))=false;
            end
        end
    end
end
%=================================================================

body=bwlabel(bw_body);
junction=bwlabel(bw_junction);

%Finding the nodes connected to each junction
%Finding the connecting points of each junction and their center
junction_node=segment_attach_to_junction(body,junction);

%=================================================================
for i=1:length(junction_node)
    if isempty(junction_node(i).ids) || length(junction_node(i).ids)==1
        bw_junction(junction==i)=0;
    end
end

for i=1:max(max(body))
    thisnode=body==i;
    tempstat=function_DetermineStatus(thisnode);
    [tx,ty]=find(tempstat==3);
    if isempty(tx)
        bw_body(body==i)=0;
    end
end
%=================================================================

body=bwlabel(bw_body);
junction=bwlabel(bw_junction);

end

