% main code for tracing

clear;clc;
% warning('off','all'); % switch of the warnings

%add path
addpath([pwd '/Codes']);
addpath([pwd '/Codes/Trace']);


%set the data set and dir information
dataset='DRIVE';
a=dir(['Segmentation/' dataset '/*.tif']);
b=dir(['Mask/' dataset '/*.tif']);


for i=1:length(a)
    Name = a(i).name(1:2);
    
    seg=imread(['Segmentation/' dataset '/' a(i).name]);
    soma=imread(['Mask/' dataset '/' b(i).name]);
    soma=uint8(soma)*255;
    
    %call main function
    [trace_result,root_node,L,root_pixel,body,junction,adj,PairAngle]=trace_process(seg+soma,soma);

    figure;imshow(trace_result);
    imwrite(trace_result,['result/' a(i).name(1:2) '_trace.tif']);
  
end


